  class CreateUserGroupRoleBindings < ActiveRecord::Migration[5.0]
    def self.up
      create_table :user_group_role_bindings do |t|
        t.references :role_document, null: false, foreign_key: { on_delete: :cascade }
        t.string :user_group_crn, null: false

        t.string :organization_crn, null: false
        t.string :customer_crn, null: false
        t.string :created_by_crn, null: false
        t.string :updated_by_crn, null: false
        t.timestamps

        t.index [:customer_crn, :organization_crn], name: "idx_customer_org"
        t.index [:customer_crn, :role_document_id, :organization_crn, :user_group_crn],
                unique: true,
                name: "idx_unique_ugrb"
      end

      create_table :user_group_role_binding_organizations do |t|
        t.references :user_group_role_binding, null: false, foreign_key: { on_delete: :cascade }
        t.string :organization_crn
      end

    end

    def self.down
      drop_table :user_group_role_binding_organizations
      drop_table :user_group_role_bindings
    end
  end
