# This file is auto-generated from the current state of the database. Instead
# of editing this file, please use the migrations feature of Active Record to
# incrementally modify your database, and then regenerate this schema definition.
#
# Note that this schema.rb definition is the authoritative source for your
# database schema. If you need to create the application database on another
# system, you should be using db:schema:load, not running all the migrations
# from scratch. The latter is a flawed and unsustainable approach (the more migrations
# you'll amass, the slower it'll run and the greater likelihood for issues).
#
# It's strongly recommended that you check this file into your version control system.

ActiveRecord::Schema.define(version: 2020_03_16_121357) do

  create_table "permissions", id: :integer, options: "ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci", force: :cascade do |t|
    t.string "action", null: false
    t.string "subject", null: false
    t.index ["action", "subject"], name: "idx_action_subject", unique: true
  end

  create_table "permissions_role_documents", id: false, options: "ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci", force: :cascade do |t|
    t.integer "role_document_id", null: false
    t.integer "permission_id", null: false
    t.index ["role_document_id", "permission_id"], name: "idx_role_documents_permissions", unique: true
  end

  create_table "role_documents", id: :integer, options: "ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci", force: :cascade do |t|
    t.string "name", null: false
    t.string "description"
    t.string "customer_crn"
    t.string "created_by_crn"
    t.string "updated_by_crn"
    t.boolean "system_defined", default: false
    t.boolean "is_deleted", default: false
    t.datetime "created_at"
    t.datetime "updated_at"
    t.bigint "organization_id"
    t.boolean "restricted", default: false, null: false
  end

  create_table "user_group_role_binding_organizations", id: :integer, options: "ENGINE=InnoDB DEFAULT CHARSET=utf8", force: :cascade do |t|
    t.integer "user_group_role_binding_id", null: false
    t.string "organization_crn"
    t.index ["user_group_role_binding_id"], name: "fk_rails_85c2d495be"
  end

  create_table "user_group_role_bindings", id: :integer, options: "ENGINE=InnoDB DEFAULT CHARSET=utf8", force: :cascade do |t|
    t.integer "role_document_id", null: false
    t.string "user_group_crn", null: false
    t.string "organization_crn", null: false
    t.string "customer_crn", null: false
    t.string "created_by_crn", null: false
    t.string "updated_by_crn", null: false
    t.datetime "created_at"
    t.datetime "updated_at"
    t.index ["customer_crn", "organization_crn"], name: "idx_customer_org"
    t.index ["customer_crn", "role_document_id", "organization_crn", "user_group_crn"], name: "idx_unique_ugrb", unique: true
    t.index ["role_document_id"], name: "fk_rails_c61bec064f"
  end

  add_foreign_key "user_group_role_binding_organizations", "user_group_role_bindings", on_delete: :cascade
  add_foreign_key "user_group_role_bindings", "role_documents", on_delete: :cascade
end
