require 'activerecord-import'
require 'role_management/stores/role_documents_directory'
require 'role_management/models'


RoleManagement::Stores::RoleDocument.find_or_create_by(
  name: "Standard User",
  customer_crn: "crn::tenant/0",
  created_by_crn: "crn::user/0",
  updated_by_crn: "crn::user/0",
  description: "",
  system_defined: true
)

RoleManagement::Stores::RoleDocument.find_or_create_by(
  name: "Administrator",
  customer_crn: "crn::tenant/0",
  created_by_crn: "crn::user/0",
  updated_by_crn: "crn::user/0",
  description: "",
  system_defined: true
)

RoleManagement::Stores::RoleDocument.find_or_create_by(
  name: "Power User",
  customer_crn: "crn::tenant/0",
  created_by_crn: "crn::user/0",
  updated_by_crn: "crn::user/0",
  description: "",
  system_defined: true
)

# Aria Hub Integration Rold Documents
RoleManagement::Stores::RoleDocument.find_or_create_by(
  name: "Tanzu Mission Control",
  customer_crn: "crn::tenant/0",
  created_by_crn: "crn::user/0",
  updated_by_crn: "crn::user/0",
  description: "Tanzu Mission Control Integration Role Document",
  system_defined: true
)

RoleManagement::Stores::Permission.import(
  [:action, :subject],
  ::RoleManagement::Models::Privileges.all_privileges,
  ignore: true
)
